/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* $Id: table.h,v 1.5 2002/11/18 09:52:49 aa5779 Exp $ */
#ifndef TABLE_H
#define TABLE_H

#include "dstring.h"
#include "interp.h"

#ifndef TABLE_IMP
extern storage_class table_storage_class;
extern storage_class hash_storage_class;
#endif

storage *table_create(interpreter *i, char *name, char *arg);
storage *hash_create(interpreter *i, char *name, char *arg);

void table_destroy(interpreter *i, storage *s);

int table_check(interpreter *i, storage *s, dstring *key);
dstring *table_get(interpreter *i, storage *s, dstring *key);

void table_put(interpreter *i, storage *s, dstring *key, dstring *val);
void table_add(interpreter *i, storage *s, dstring *key, dstring *val);

void table_remove(interpreter *i, storage *s, dstring *key);

dstring *table_first(interpreter *i, storage *s, void **iter);
dstring *table_next(interpreter *i, storage *s, void **iter);
void table_enditer(interpreter *i, storage *s, void **iter);

int table_numofitems(interpreter *i, storage *s);

dstring *table_seek(interpreter *i, storage *s, void **iter, dstring *key);

storage *table_clone(storage *src);

#endif
