/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* $Id: uds.h,v 1.3 2002/07/24 10:10:20 aa5779 Exp $ */
#ifndef UDS_H
#define UDS_H

#include "dstring.h"
#include "interp.h"

#ifndef UDS_IMP
extern storage_class uds_storage_class;
#endif

storage *uds_create(interpreter *i, char *name, char *arg);

void uds_destroy(interpreter *i, storage *s);

int uds_check(interpreter *i, storage *s, dstring *key);
dstring *uds_get(interpreter *i, storage *s, dstring *key);

void uds_put(interpreter *i, storage *s, dstring *key, dstring *val);
void uds_add(interpreter *i, storage *s, dstring *key, dstring *val);

void uds_remove(interpreter *i, storage *s, dstring *key);

dstring *uds_first(interpreter *i, storage *s, void **iter);
dstring *uds_next(interpreter *i, storage *s, void **iter);
void uds_enditer(interpreter *i, storage *s, void **iter);

int uds_numofitems(interpreter *i, storage *s);

void uds_init(interpreter *i, storage *s, value *args);

dstring *uds_seek(interpreter *i, storage *s, void **iter, dstring *key);

#endif
